<div class="d-flex justify-content-center align-items-center px-2 mt-5">
  <div class="col-12 col-lg-4">
    <div class="d-flex justify-content-center flex-column gap-5">
      <ng-container *transloco="let t; prefix: 'requestApplication'">
        <h1 class="text-primary">{{ t('title') }}</h1>

        <form [formGroup]="applicationForm" id="applicationForm" (ngSubmit)="onSubmit()"
              class="d-flex flex-column gap-2" *ngIf="credentials.password === '' && credentials.username === ''">

          <div formGroupName="applicant">
            <mat-form-field class="w-100" appearance="outline">
              <mat-label>{{ t('email') }}</mat-label>
              <input matInput formControlName="email" id="email" type="email" required
                     [placeholder]="t('emailPlaceholder')">
              @if (applicationForm.get('applicant.email')?.invalid && (applicationForm.get('email')?.dirty ||
                applicationForm.get('applicant.email')?.touched)) {
                  <mat-error *ngIf="applicationForm.get('applicant.email')?.hasError('required') ||
                          applicationForm.get('applicant.email')?.hasError('email')">
                    {{ applicationForm.get('applicant.email')?.hasError('required') ? t('emailRequired') : t('emailValidation')}}
                  </mat-error>
              }
            </mat-form-field>
          </div>

         <div>
            <mat-form-field class="w-100" appearance="outline">
              <mat-label>{{ t('organization') }}</mat-label>
              <input matInput formControlName="organization" id="organization" type="text" required
                     [placeholder]="t('organizationPlaceholder')">
              @if (applicationForm.get('organization')?.invalid && (applicationForm.get('organization')?.dirty ||
                applicationForm.get('organization')?.touched)) {
                  <mat-error>{{ applicationForm.get('organization')?.hasError('required') ? t('required') : t('notValidChar') }}</mat-error>
              }
            </mat-form-field>
          </div>

          <div formGroupName="participantType">
            <mat-form-field class="w-100" appearance="outline">
              <mat-label>{{ t('participant') }}</mat-label>
              <mat-select formControlName="id" id="participantType"
                          [placeholder]="t('participantPlaceholder')">
                @for (participant of participants; track participant) {
                  <mat-option [value]="participant.id">{{ participant.label }}</mat-option>
                } @empty {
                  {{ t('participantEmpty') }}
                }
              </mat-select>
              @if (applicationForm.get('participantType.id')?.invalid && (applicationForm.get('participantType.id')?.dirty ||
                applicationForm.get('participantType.id')?.touched)) {
                <mat-error>{{ t('participantValidation') }}</mat-error>
              }
            </mat-form-field>
          </div>

          <div formGroupName="applicant">
            <mat-form-field class="w-100" appearance="outline">
              <mat-label>{{ t('surname') }}</mat-label>
              <input matInput formControlName="lastName" id="surname" type="text" required
                     [placeholder]="t('surnamePlaceholder')">
              @if (applicationForm.get('applicant.lastName')?.invalid && (applicationForm.get('applicant.lastName')?.dirty ||
                applicationForm.get('applicant.lastName')?.touched)) {
                <mat-error>{{ applicationForm.get('applicant.lastName')?.hasError('required') ? t('required') : t('notValidChar') }}</mat-error>
              }
            </mat-form-field>
          </div>

          <div formGroupName="applicant">
            <mat-form-field class="w-100" appearance="outline">
              <mat-label>{{ t('name') }}</mat-label>
              <input matInput formControlName="firstName" id="name" type="text" required
                     [placeholder]="t('namePlaceholder')">
              @if (applicationForm.get('applicant.firstName')?.invalid && (applicationForm.get('applicant.firstName')?.dirty ||
                applicationForm.get('applicant.firstName')?.touched)) {
                <mat-error>{{ applicationForm.get('applicant.firstName')?.hasError('required') ? t('required') : t('notValidChar') }}</mat-error>
              }
            </mat-form-field>
          </div>

          <div formGroupName="applicant">
            <mat-form-field class="w-100" appearance="outline">
              <mat-label>{{ t('username') }}</mat-label>
              <input matInput formControlName="username" type="text" id="username" required
                     [placeholder]="t('usernamePlaceholder')">
              @if (applicationForm.get('applicant.username')?.invalid && (applicationForm.get('applicant.username')?.dirty ||
                applicationForm.get('applicant.username')?.touched)) {
                <mat-error>{{ applicationForm.get('applicant.username')?.hasError('required') ? t('required') : t('notValidChar') }}</mat-error>
              }
            </mat-form-field>
          </div>
          <div formGroupName="applicant">
            <mat-form-field class="w-100" appearance="outline">
              <mat-label>{{ t('password') }}</mat-label>
              <input matInput formControlName="password" id="password" [type]="passwordVisible ? 'text' : 'password'"
                     required [placeholder]="t('passwordPlaceholder')" />
              <button type="button" mat-icon-button matSuffix (click)="passwordVisible = !passwordVisible"
                      [attr.aria-label]="'Hide password'" [attr.aria-pressed]="!passwordVisible">
                <mat-icon>{{passwordVisible ? 'visibility' : 'visibility_off'}}</mat-icon>
              </button>
              <mat-hint>
                <span class="text-black-50">The password must be between</span>
                <span
                  [class.text-success]="!applicationForm.get('applicant.password')?.hasError('minLength') && !applicationForm.get('password')?.hasError('maxLength')"
                  [class.text-danger]="applicationForm.get('applicant.password')?.hasError('minLength') || applicationForm.get('password')?.hasError('maxLength')">
                  10 and 64 characters long
                </span>,
                <span class="text-black-50">and contain at least</span>
                <span [class.text-success]="!applicationForm.get('applicant.password')?.hasError('uppercase')"
                      [class.text-danger]="applicationForm.get('applicant.password')?.hasError('uppercase')">
                  1 uppercase letter (A-Z)
                </span>,
                <span [class.text-success]="!applicationForm.get('applicant.password')?.hasError('lowercase')"
                      [class.text-danger]="applicationForm.get('applicant.password')?.hasError('lowercase')">
                  1 lowercase letter (a-z)
                </span>,
                <span [class.text-success]="!applicationForm.get('applicant.password')?.hasError('numeric')"
                      [class.text-danger]="applicationForm.get('applicant.password')?.hasError('numeric')">
                  1 number (0-9)
                </span>,
                <span [class.text-success]="!applicationForm.get('applicant.password')?.hasError('specialChar')"
                      [class.text-danger]="applicationForm.get('applicant.password')?.hasError('specialChar')">
                  1 special character (!£%&&#64; etc).
                </span>,
                <span [class.text-success]="!applicationForm.get('applicant.password')?.hasError('forbidden')"
                      [class.text-danger]="applicationForm.get('applicant.password')?.hasError('forbidden')">
                  The password not contain portions of Email, Organisation name, Name, Surname, or Username greater than
                  4 characters.
                </span>
              </mat-hint>
            </mat-form-field>
          </div>

          <div formGroupName="applicant">
            <mat-form-field class="w-100 mt-custom" appearance="outline">
              <mat-label>{{ t('confirmPassword') }}</mat-label>
              <input matInput formControlName="confirmPassword" id="confirmPassword"
                     [type]="passwordConfirmVisible ? 'text' : 'password'" required
                     [placeholder]="t('confirmPasswordPlaceholder')">
              <button type="button" mat-icon-button matSuffix (click)="passwordConfirmVisible = !passwordConfirmVisible"
                      [attr.aria-label]="'Hide password'" [attr.aria-pressed]="!passwordConfirmVisible">
                <mat-icon>{{passwordConfirmVisible ? 'visibility' : 'visibility_off'}}</mat-icon>
              </button>
              @if (applicationForm.get('applicant.confirmPassword')!.hasError('noMatch')) {
                <mat-error>{{ t('noMatch') }}</mat-error>
              }
            </mat-form-field>
          </div>

          <div>
            <button mat-flat-button id="submitButton" type="submit" color="accent"
                    [disabled]="loading || !applicationForm.valid" style="min-width: 150px">
              <mat-spinner *ngIf="loading" diameter="25"></mat-spinner>
              <span *ngIf="!loading">{{ t('button') }}</span>
            </button>
          </div>
        </form>

        <div *ngIf="credentials.password !== '' && credentials.username !== ''" class="d-flex flex-column gap-5">
          <h6 >{{ t('result.subTitle') }}</h6>

          <div>
            <div class="lead text-muted">{{ t('result.username') }}: {{ credentials.username }}</div>
            <div class="lead text-muted">{{ t('result.password') }}: {{ credentials.password }}</div>
          </div>

          <div>
            <button mat-flat-button color="accent" (click)="navigateToOnboarding()">{{ t('result.button') }}</button>
          </div>
        </div>

      </ng-container>
    </div>
  </div>
</div>
